import { useState, useRef, useEffect } from "react";
import { YMaps, Map, Placemark, SearchControl } from "@pbe/react-yandex-maps";

function YandexMap({ selectAddressHandler, toggleModalHandler }) {
  const [coordinates, setCoordinates] = useState([55.751574, 37.573856]);
  const [address, setAddress] = useState("");
  const handleSearchSelect = async (e) => {
    const result = e.get("target").getResultsArray()[0];
  };

  const handleDragEnd = async (e) => {
    const coords = e.get("target").geometry.getCoordinates();
    setCoordinates(coords);
    await getAddress(coords);
  };
  const getAddress = async (coords) => {
    const [lat, lon] = coords;
    const apiKey = "23c5ac38-b1d9-4b9e-8b56-136bd8d7eba9";
    const response = await fetch(
      `https://geocode-maps.yandex.ru/1.x/?apikey=${apiKey}&geocode=${lon},${lat}&format=json&lang=en_US`
    );
    const data = await response.json();
    const address =
      data.response.GeoObjectCollection.featureMember[0]?.GeoObject
        ?.metaDataProperty?.GeocoderMetaData?.text || "Address not found";
    setAddress(address);
    selectAddressHandler(address);
    toggleModalHandler();
  };
  const handleMapClick = async (e) => {
    const coords = e.get("coords");
    setCoordinates(coords);
    await getAddress(coords);
  };
  return (
    <>
      <YMaps
        query={{
          apikey: "23c5ac38-b1d9-4b9e-8b56-136bd8d7eba9",
          lang: "en_US",
        }}
      >
        <Map
          defaultState={{ center: [55.751574, 37.573856], zoom: 9 }}
          width="100%"
          height="500px"
          onClick={handleMapClick}
        >
          <SearchControl
            options={{
              float: "left",
              provider: "yandex#search",
            }}
            onResultSelect={handleSearchSelect}
          />
          <Placemark
            geometry={coordinates}
            options={{ draggable: true }}
            onDragEnd={handleDragEnd}
          />
        </Map>
        {address && <div>Address: {address}</div>}
      </YMaps>
    </>
  );
}

export default YandexMap;
